<template>
  <q-layout view="hHr lpR lFr">
    <q-header
        elevated
        class="text-primary"
        :class="$q.dark.isActive  ? 'bg-dark' : 'bg-white'"
        height-hint="98"
        data-wails-drag
    >
      <q-toolbar data-wails-drag>
        <q-btn
            dense
            flat
            round
            icon="menu"
            @click="toggleLeftDrawer"
            data-wails-no-drag
        />

        <q-toolbar-title data-wails-drag></q-toolbar-title>

        <div data-wails-no-drag class="nav__right-actions">
          <q-btn
              dense
              flat
              round
              :icon="maximised ? 'fullscreen_exit': 'fullscreen'"
              @click.prevent="toggleFullScreen"
          />
          <q-btn
              dense
              flat
              round
              :icon="$q.dark.isActive ? 'light_mode' : 'dark_mode'"
              @click="toggleDarkMode"
          />
          <q-btn
              dense
              flat
              round
              icon="close"
              @click="quit"
          />
        </div>

      </q-toolbar>
    </q-header>

    <q-drawer
        show-if-above
        v-model="leftDrawerOpen"
        side="left"
        bordered
        data-wails-no-drag
    >
      <FolderList/>
    </q-drawer>

    <q-page-container data-wails-no-drag>
      <router-view/>
    </q-page-container>
  </q-layout>
</template>

<style lang="scss">
.nav {
  &__right-actions {
    display: flex;
    align-items: center;
    gap: 8px;
    justify-content: flex-end;
  }
}
</style>

<script lang="ts">
import {defineComponent} from 'vue';

import FolderList from "../components/FolderList.vue";

export default defineComponent({
  components: {FolderList},

  data: () => ({
    leftDrawerOpen: false,
    maximised: false
  }),

  methods: {
    toggleDarkMode () {
      this.$q.dark.toggle()
    },

    toggleLeftDrawer () {
      this.leftDrawerOpen = !this.leftDrawerOpen;
    },

    quit() {
      window.runtime.Quit();
    },

    toggleFullScreen() {
      this.maximised = !this.maximised;
      window.runtime.WindowToggleMaximise();
    }
  }
});
</script>
